xquery version "3.1";
(:~  
 : Trivia App Module ("main", "http://dev.met.de/via/trivia")
 : *******************************************************************************************
 : This is a module defining the functionalities of the app
 :  
 : @version 0.1 (2019-04-17)
 : @status develop
 : @author Uwe Sikora
 : 
 : Terms:
 : ******
 : via-object : a json string produced in via
 : via-surfaces : all images incl. metadata represented in via
 : shape-object
 : 
 :)


module namespace trivia="http://dev.met.de/via/trivia";
import module namespace config="http://dev.met.de/via/config" at "xmldb:exist:///db/apps/via/modules/config.xqm";
import module namespace via="http://dev.met.de/via/main" at "xmldb:exist:///db/apps/via/modules/via.xqm";
import module namespace tgclient="https://sade.textgrid.de/ns/tgclient" at "xmldb:exist:///db/apps/via/modules/tgclient.xqm";
import module namespace console="http://exist-db.org/xquery/console";
declare default element namespace "http://dev.met.de/via/";
declare namespace test="http://exist-db.org/xquery/xqsuite";
declare namespace vias="http://dev.met.de/via/schema";
declare namespace svg="http://www.w3.org/2000/svg";
declare namespace tei="http://www.tei-c.org/ns/1.0";
declare namespace tg="http://textgrid.info/namespaces/metadata/core/2010";
declare namespace xlink="http://www.w3.org/1999/xlink";
declare namespace output = "http://www.w3.org/2010/xslt-xquery-serialization";

(:############################# Modules Variables #############################:)

declare variable $trivia:real-json := '{"textgrid:3r3p5":{"size":-1,"filename":"","zones":[],"file_attributes":{"textRef":"","image_url":"","naturalHeight":926,"imageRef":"textgrid:3r3hn","title":"trivia test 2","naturalWidth":676},"id":"textgrid:3r3p5","regions":[]}}';

declare variable $trivia:real-json2 := '{"textgrid:3r3p5":{"size":-1,"filename":"","zones":[{"surfaceId":"textgrid:3r3p5","data":{"region_attributes":{"zoneId":"zone0"},"shape_attributes":{"name":"point","cx":647,"cy":1569}},"index":0,"id":"zone0"},{"surfaceId":"textgrid:3r3p5","data":{"region_attributes":{"zoneId":"zone1"},"shape_attributes":{"name":"point","cx":625,"cy":2359}},"index":1,"id":"zone1"},{"surfaceId":"textgrid:3r3p5","data":{"region_attributes":{"zoneId":"zone2"},"shape_attributes":{"name":"point","cx":922,"cy":3237}},"index":2,"id":"zone2"},{"surfaceId":"textgrid:3r3p5","data":{"region_attributes":{"zoneId":"zone3"},"shape_attributes":{"name":"point","cx":516,"cy":494}},"index":3,"id":"zone3"}],"file_attributes":{"textRef":"","image_url":"","naturalHeight":926,"imageRef":"textgrid:3r3hn","title":"trivia test 2","naturalWidth":676},"id":"textgrid:3r3p5","regions":[{"region_attributes":{"zoneId":"zone0"},"shape_attributes":{"name":"point","cx":647,"cy":1569}},{"region_attributes":{"zoneId":"zone1"},"shape_attributes":{"name":"point","cx":625,"cy":2359}},{"region_attributes":{"zoneId":"zone2"},"shape_attributes":{"name":"point","cx":922,"cy":3237}},{"region_attributes":{"zoneId":"zone3"},"shape_attributes":{"name":"point","cx":516,"cy":494}}]}}';

declare variable $trivia:export-sample := '{"id":"textgrid:3r3p5","filename":"","size":-1,"file_attributes":{"textRef":"textgrid:3r3v3","image_url":"","naturalHeight":926,"imageRef":"textgrid:3r3hn","title":"trivia test 2 (mod 2)","naturalWidth":676},"regions":[{"region_attributes":{"zoneId":"zone0","childOf":"not_defined"},"shape_attributes":{"name":"point","cx":647,"cy":1569}},{"region_attributes":{"zoneId":"zone1","childOf":"not_defined"},"shape_attributes":{"name":"point","cx":625,"cy":2359}},{"region_attributes":{"zoneId":"zone2","childOf":"zone1"},"shape_attributes":{"name":"point","cx":922,"cy":3237}},{"region_attributes":{"zoneId":"zone3","childOf":"zone4"},"shape_attributes":{"name":"point","cx":516,"cy":494}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone4","name":"Große Sefirah","mapItem":"http://www.semanticweb.org/jahnke/ontologies/2019/3/ilanot#Assiah","childOf":"zone1"},"shape_attributes":{"name":"circle","r":164,"cx":600,"cy":832}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone5","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":122,"cx":300,"cy":1964}}],"zones":[{"surfaceId":"textgrid:3r3p5","id":"zone0","index":0,"data":{"region_attributes":{"zoneId":"zone0","childOf":"not_defined"},"shape_attributes":{"name":"point","cx":647,"cy":1569}}},{"surfaceId":"textgrid:3r3p5","id":"zone1","index":1,"data":{"region_attributes":{"zoneId":"zone1","childOf":"not_defined"},"shape_attributes":{"name":"point","cx":625,"cy":2359}},"children":[{"surfaceId":"textgrid:3r3p5","id":"zone2","index":2,"data":{"region_attributes":{"zoneId":"zone2","childOf":"zone1"},"shape_attributes":{"name":"point","cx":922,"cy":3237}}},{"surfaceId":"textgrid:3r3p5","id":"zone4","index":4,"children":[{"surfaceId":"textgrid:3r3p5","id":"zone3","index":3,"data":{"region_attributes":{"zoneId":"zone3","childOf":"zone4"},"shape_attributes":{"name":"point","cx":516,"cy":494}}}],"data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone4","name":"Große Sefirah","mapItem": "http://www.semanticweb.org/jahnke/ontologies/2019/3/ilanot#Assiah","childOf":"zone1"},"shape_attributes":{"name":"circle","r":164,"cx":600,"cy":832}}}]},{"surfaceId":"textgrid:3r3p5","id":"zone5","index":5,"data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone5","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":122,"cx":300,"cy":1964}}}]}';
(:############################# Modules Functions #############################:)


(: *****************************************************************
 : ********     TRIVIA Surface metadata
 : ***
 : :)

declare function trivia:get-trivia-surface-metadata
    ( $trivia-surface as map(*) ) as item(){
    let $data :=$trivia-surface
    return 
        map{
            'id'                : $trivia-surface?id,
            'name'              : $trivia-surface?name,
            'file_attributes'   : $trivia-surface?file_attributes,
            'size'              : $trivia-surface?size,
            'filename'          : $trivia-surface?filename
        }        
};


(: *****************************************************************
 : ********     TRIVIA Surface to TEI-Resource
 : ***
 : :)

(: deprecated ; not used
declare function trivia:trivia-data-as-list
    ( $trivia-json-object as map(*) ) as item()*{
    let $array := array{
        
        for $trivia-surface-id in map:keys( $trivia-json-object )    
        let $trivia-surface := $trivia-json-object( $trivia-surface-id)
        return (
            map{ "uri" : $trivia-surface-id, "data" : $trivia-surface}
        )
    }
    return $array
};:)


(:~  
 : trivia:update-trivia-xml-within-textgrid()
 : function to update a trivia textgrid resource with new data
 :
 : @param $tg-config the tgcrud congig
 : @param $tg-uri a textgrid uri
 : @param $trivia-xml the new xml structure
 : @return tgcrud metadata header
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:update-resource-within-textgrid
    ( $tg-config as map(*), $tg-uri as xs:string, $new-xml as node() ) as item()*{
        let $sid := $tg-config?sid
        let $crud := $tg-config?tgcrudURL
        let $requested-resource-metadata := tgclient:getMeta($tg-uri, $crud, $sid)
        let $create-revision := tgclient:revision( $sid, $crud, $new-xml, $requested-resource-metadata )
        return $create-revision
    };


(: #################################################################
 : ********     CONVERSION FROM BACKEND -> FRONTEND
 : ***
 : :)

(: ############################ NEW :)
declare function trivia:build-trivia-object-from-textgrid-resources
    ( $trivia-resource-uri as xs:string, $sid as xs:string ) as item()* {
    
    let $config := map{ "sid" : $sid, "tgcrudURL" : $via:tg-config?tgcrudURL }
    let $trivia-map := tgclient:get-resource($config, $trivia-resource-uri)
    let $metadata := $trivia-map?metadata
    let $uri := $trivia-map?uri
    let $trivia-xml := $trivia-map?data
    
    let $linked-tei-uri := data( $trivia-map?data//textRef )
    let $tei-xml := tgclient:get-resource($config, $linked-tei-uri)?data

    return 
        if ( $trivia-xml/trivia and $tei-xml ) then (
            map{
                "uri"   : $uri,
                "title" : data( $metadata//tg:generic/tg:provided/tg:title ),
                "object": trivia:convert-xml-resources-to-trivia-surface( $tei-xml, $trivia-xml )
            }
        ) else (
            element {"error"}{"resource is not a trivia resource!"}
        )
    
}; 

declare function trivia:convert-xml-resources-to-trivia-surface
    ( $tei-xml as node(), $trivia-xml as node() ) as item()*{
    
    let $svg-shapes := $trivia-xml//svg:svg/svg:g/node()[ not(self::svg:image) ]
    let $zone-structure := $tei-xml//tei:sourceDoc/tei:surface
    let $trivia-shapes := trivia:convert-tei-zones-to-trivia-shapes( $zone-structure/tei:zone, $svg-shapes, ())
    
    
    let $filename := $trivia-xml//metadata/title
    let $size := $trivia-xml//metadata/size
    let $attributes := $trivia-xml//metadata/attributes/node()
    let $file-attributes := via:xml-to-map( $attributes )
    let $file-attributes := if ( $trivia-xml//svg:image/@height ) then ( 
            via:map-put( $file-attributes, "naturalHeight", number( data($trivia-xml//svg:image/@height) ) ) 
        ) else ( $file-attributes )
    let $file-attributes := if ( $trivia-xml//svg:image/@width ) then (
            via:map-put( $file-attributes, "naturalWidth", number( data($trivia-xml//svg:image/@width) ) )
        ) else ( $file-attributes )
        
    return 
        map{
            "filename" : "",
            "size" : number( data($size) ),
            "file_attributes" : $file-attributes,
            "regions" : array{ $trivia-shapes }
        }
        
};

declare function trivia:convert-tei-zones-to-trivia-shapes
    ( $tei-xml-zones as node()*, $svg-xml-shapes as node()*, $parent-id as xs:string?) as item()*{
    
    for $zone in $tei-xml-zones
    let $id := data($zone/@xml:id)
    let $name := data($zone/@n)
    let $mapItem := data($zone/@type)
    let $shape := $svg-xml-shapes[@id = $id]
    let $region-attributes := $zone/tei:note/tei:fs/tei:f
    let $child-zones := $zone/tei:zone
    return(
        map{
            "region_attributes" : map:new ( 
                let $map := map{
                        "zoneId": $id ,
                        "name": if ($name) then ($name) else ("")
                    }
                let $map := map:new ((
                        $map, 
                        for $att in $region-attributes
                        return map:entry( data($att/@name), normalize-space( string-join(data($att/node()/string()))) )
                    ))
                let $map := if ($parent-id) then ( via:map-put($map, "childOf", $parent-id) ) else ( $map )
                return $map
                ),
            "shape_attributes" : map:new (
                        
                let $map := map{"name" : substring-after($shape/name(), ":")} 
                (:let $map := map{"name" : $shape/name() } :)
                let $map := map:new ( 
                    (
                        $map, 
                        for $att in $shape/@*
                        where $att/name() != "id" and $att/name() != ''
                        return map:entry( $att/name(), data($att) )
                    ) 
                )
                return trivia:convert-shape-to-via-shape( $map )
            )
        },
        if ( $child-zones ) then (
            trivia:convert-tei-zones-to-trivia-shapes( $child-zones, $svg-xml-shapes, $id )
        ) else ()
    )
};

(: ############################ OLD :)
(:~  
 : trivia:get-trivia-object-from-textgrid()
 : [via:get-trivia-object-from-textgrid()]
 : @description gets a trivia resource from textgrid
 :
 : @param $textgrid-uri uri of a textgrid resource
 : @param $sid session id to authenticate at tgcrud
 : @return 
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:get-trivia-object-from-textgrid
    ( $textgrid-uri as xs:string, $sid as xs:string ) as item()* {
    
    let $config := map{ "sid" : $sid, "tgcrudURL" : $via:tg-config?tgcrudURL, "pid" : $via:tg-config?pid }
    let $trivia-map := tgclient:get-resource($config, $textgrid-uri)

    let $data := $trivia-map?data
    let $metadata := $trivia-map?metadata
    let $uri := $trivia-map?uri
    return 
        if ( $data/trivia ) then (
            trivia:trivia-data-object-from-trivia-xml($data, $uri, $metadata)
        ) else (
            element {"error"}{"resource is not a trivia resource!"}
        )
}; 


(:~  
 : trivia:trivia-data-object-from-trivia-xml()
 : [via:trivia-data-object-from-trivia-xml()]
 : function to create a trivia object from a trivia xml
 :
 : @param $trivia-xml a xml resource
 : @param $uri the uri of a resource
 : @param metadata the textgrid metadata record
 : @return a map containing uri, title and object
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:trivia-data-object-from-trivia-xml
    ( $trivia-xml as node(), $uri, $metadata ) as item()* {
    map{
        "uri"   : $uri,
        "title" : $metadata//tg:generic/tg:provided/tg:title/string(),
        "object": trivia:convert-tble-object-to-shapes-surface( $trivia-xml/trivia )
    }
};


(:~  
 : trivia:convert-tble-object-to-shapes-surface()
 : [via:convert-tble-object-to-shapes-surface()]
 : [local:convert-tble-object-to-shapes-object()]
 : function converting a tble xml into the apps surface object ("shapes-surface")
 :
 : @param $via-shape the via shape being converted
 : @return map()* the converted svg shape
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:convert-tble-object-to-shapes-surface
    ( $tble-xml as node() ) as item()* {
    
    let $filename := $tble-xml/metadata/title
    let $size := $tble-xml/metadata/size
    let $attributes := $tble-xml/metadata/attributes/node()
    let $file-attributes := via:xml-to-map( $tble-xml/metadata/attributes )?attributes
    let $file-attributes := if ( $tble-xml//svg:image/@height ) then ( 
            via:map-put( $file-attributes, "naturalHeight", number( data($tble-xml//svg:image/@height) ) ) 
        ) else ( $file-attributes )
    let $file-attributes := if ( $tble-xml//svg:image/@width ) then (
            via:map-put( $file-attributes, "naturalWidth", number( data($tble-xml//svg:image/@width) ) )
        ) else ( $file-attributes )
    
    (:
    let $file-attributes := via:map-put( $file-attributes, "imageRef", data( $tble-xml//imageRef/string() ) )
    let $file-attributes := via:map-put( $file-attributes, "textRef", data( $tble-xml//textRef/string() ) )
    :)
    return map {
        "filename" : "",
        "size" : number( data($size) ),
        "file_attributes" : $file-attributes,
        "regions" : array{
            for $shape in $tble-xml/svg:svg/svg:g/node()[name() != "svg:image"]
            let $id := $shape/@id
            let $name := substring-after($shape/name(), ":")
            let $annotation := $tble-xml//annotation[@target = '#'||$id][1]
            where $shape/name() != ''
            return 
                map{ 
                    "shape_attributes" : map:new (
                        
                        let $map := map{"name" : $name} 
                        let $map := map:new ( 
                            (
                                $map, 
                                for $att in $shape/@*
                                where $att/name() != "id" and $att/name() != ''
                                return map:entry( $att/name(), data($att) )
                            ) 
                        )
                        return trivia:convert-shape-to-via-shape( $map )
                    ), 
                    "region_attributes" : map:new ( 
                            (
                                for $ann in $annotation/node() 
                                return via:xml-to-map( $ann )
                            ) 
                        )
                }
        }
    }
};


(:~  
 : trivia:convert-shapes-surface-to-via-surface()
 : [via:convert-shapes-surface-to-via-surface()]
 : [local:convert-shapes-object-to-via-object()]
 : function converting an apps surface object ("shapes-surface") into a via surface
 :
 : @param $shapes-surface the surface object being converted
 : @return map()* the converted via surface
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @comment this function is somewhat dirty and needs cleening
 :          look if trivia:convert-shape-to-via-shape is necessary
 : @author Uwe Sikora
 :)
declare function trivia:convert-shapes-surface-to-via-surface
    ( $shapes-surface as map(*) ) as map() {
    
    map:new((
        for $key in map:keys($shapes-surface)
        where $key != "regions"
        return map:entry( $key, $shapes-surface($key) ),
        
        map:entry( 
            "regions", array{
                
                for $region at $nr in $shapes-surface?regions?*
                
                let $region-attributes := $region("region_attributes")
                let $shape-attributes := $region("shape_attributes")
                let $convert-shape-attributes-to-via-encoding := trivia:convert-shape-to-via-shape( $shape-attributes )
                return map{ 
                    "region_attributes" : $region-attributes,
                    "shape_attributes" : $convert-shape-attributes-to-via-encoding
                }
            }
        )
    ))
};


(:~  
 : trivia:convert-shape-to-via-shape()
 : [via:convert-shape-to-via-shape()]
 : [local:convert-shapes-to-via-regions]
 : function converting an apps surface shape ("shape") into a via shape
 :
 : @param $exchange-shape the shape being converted
 : @return map()* the converted via shape
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @comment this function is somewhat dirty and needs cleening
 : @author Uwe Sikora
 :)
declare function trivia:convert-shape-to-via-shape
    ( $exchange-shape as map() ) as map()? {
    
    let $name := $exchange-shape("name")
    let $map := map{"name" : $name}
    return 
        if ($name = ("polyline", "polygon") ) then (
            let $points := $exchange-shape("points")
            let $coordinates := tokenize($points, " ")
            let $x := for $set in $coordinates return via:cast-to-integer( tokenize($set, ",")[1] )
            let $y := for $set in $coordinates return via:cast-to-integer( tokenize($set, ",")[2] )
            
            let $map-put := via:map-put($map, "all_points_x", array {$x})
            let $map-put := via:map-put($map-put, "all_points_y", array {$y})
            return $map-put
        )
        
        else if ( $name = ( "circle" ) and $exchange-shape("r") = 2 ) then (
            let $map-put := via:map-put($map, "name", "point")
            let $map-put := map:new ( 
                (
                    $map-put, 
                    for $att in map:keys($exchange-shape) 
                    where $att != "name"
                    where $att != "r"
                    return map:entry( $att, via:cast-to-integer( $exchange-shape($att) ) )
                ) 
            )
            return $map-put
        ) 
        
        else (
            let $map-put := map:new ( 
                (
                    $map, 
                    for $att in map:keys($exchange-shape) 
                    return map:entry( $att, via:cast-to-integer( $exchange-shape($att) ) )
                ) 
            )
            return $map-put
        )
};


(:~  
 : trivia:create-svg-xml-elements()
 : [via:create-svg-xml-elements()]
 : function to create svg xml elements from shapes maps
 :
 : @param $shapes the shape maps
 : @return node() the svg xml elements
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-svg-xml-elements
    ( $shapes as map()*, $attributes as map(*)? ) as item()* {
    
    for $shape in $shapes
    let $name := $shape("name")
    return 
        if ( $name = ("circle", "polygon", "polyline", "rect", "ellipse", "line", "path") ) then (
            element { QName("http://www.w3.org/2000/svg", "svg:"||$name) }{
                for $att in map:keys($shape)
                where $att != "name"
                return 
                    attribute {$att}{ $shape($att) },
                    
                if ( count($attributes) > 0 ) then (
                    for $att2 in map:keys($attributes)
                    return 
                        attribute {$att2}{ $attributes($att2) }
                ) else ()
            }
        ) else ()
        
};

(: #################################################################
 : ********     CONVERSION FROM FRONTEND -> BACKEND
 : ***
 : :)

declare function trivia:get-referenced-text-resource-uri-from-trivia-surface
    ( $trivia-object as map(*) ) as item()* {
    
    data( $trivia-object?file_attributes?textRef )
};

declare function trivia:get-referenced-text-resource-from-trivia-surface-via-textgrid
    ( $trivia-object as map(*), $sid as xs:string ) as item()* {
    
    let $linked-tei-uri := trivia:get-referenced-text-resource-uri-from-trivia-surface( $trivia-object )
    let $tei-resource := tgclient:get-resource(map{ "sid" : $sid, "tgcrudURL" : $via:tg-config?tgcrudURL }, $linked-tei-uri)
    return $tei-resource?data
};

(: *********************************************
 : ****  TRIVIA Surface to TEI-Resource
 : ***
 : :)

(: ################################ Creating tei resource ################################### :)
(:~  
 : trivia:create-tei-xml-resource()
 : function to create a trivia textgrid resource
 :
 : @param $trivia-surface the trivia surface
 : @return tgcrud metadata header
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-tei-xml-resource-from-trivia-surface
    ( $trivia-surface as map(*) ) as item()*{
    
    (: collecting all the attributes of a surface:)
    let $metadata := trivia:get-trivia-surface-metadata( $trivia-surface )
    let $id := $metadata?id
    let $name := $metadata?name
    let $file-attributes := $metadata?file_attributes
    
    let $trivia-zones := $trivia-surface?zones
    
    let $zones := trivia:create-zones-xml-from-trivia-zones( $trivia-zones )
    (:let $source-doc-node := trivia:create-tei-sourceDoc-node-fr( $file-attributes?imageRef, $zones ):)
    let $source-doc-node := trivia:create-tei-sourceDoc-node-from-trivia-surface( $trivia-surface, $zones )
    return trivia:create-tei-xml-resource-from-template( $source-doc-node )
};


(: ################################ Updating existing tei resource ################################### :)
(:~  
 : trivia:update-tei-xml-resource()
 : function to update a tei textgrid resource with new sourceDoc
 :
 : @param $tei-resource the tei resource
 : @param $trivia-surface the trivia surface
 : @return tgcrud metadata header
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:update-tei-xml-resource-from-trivia-surface
    ( $tei-resource as node(), $trivia-surface as map(*) ) as item(){
    
    let $metadata := trivia:get-trivia-surface-metadata( $trivia-surface )
    let $file-attributes := $metadata?file_attributes
    let $trivia-zones := $trivia-surface?zones
    let $zones := trivia:create-zones-xml-from-trivia-zones( $trivia-zones )
    let $source-doc-node := trivia:create-tei-sourceDoc-node( $file-attributes?imageRef, $zones )
    return trivia:replace-sourcedoc( $tei-resource, $source-doc-node )
};



(:~  
 : trivia:create-tei-sourceDoc-node()
 : function to create tei sourceDoc chunk
 :
 : @param $image-uri the uri of an image in textgrid
 : @param $trivia-zones the trivia zones of a surface
 : @return tgcrud metadata header
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-tei-sourceDoc-node
    ( $image-uri as xs:string, $trivia-zones as node()* ) as node()* {
    
    element { QName('http://www.tei-c.org/ns/1.0', "sourceDoc") } {
        element { QName('http://www.tei-c.org/ns/1.0', "surface") } {
            attribute facs { $image-uri },
            $trivia-zones
        }
    }
};


declare function trivia:create-tei-sourceDoc-node-from-trivia-surface
    ( $trivia-surface as map(*), $tei-zones as node()* ) as node()* {
    
    let $file-attributes := $trivia-surface?file_attributes
    let $image-uri := $file-attributes?imageRef
    let $height := $file-attributes?naturalHeight
    let $width := $file-attributes?naturalWidth
    return 
        element { QName('http://www.tei-c.org/ns/1.0', "sourceDoc") } {
            element { QName('http://www.tei-c.org/ns/1.0', "surface") } {
                attribute facs { $image-uri },
                attribute ulx { $width },
                attribute lry { $height },
                $tei-zones
            }
        }
};


(:~  
 : trivia:create-tei-xml-resource-from-template()
 : function to create tei sourceDoc chunk
 :
 : @param $image-uri the uri of an image in textgrid
 : @param $trivia-zones the trivia zones of a surface
 : @return tei resource
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-tei-xml-resource-from-template
    ( $source-doc-node as node() ) as item(){
    
    let $tei-template := doc($config:data-root||"/templates/teip5_sourcedoc.tmpl.xml")
    return trivia:replace-sourcedoc( $tei-template, $source-doc-node )
};


(:~  
 : trivia:replace-sourcedoc()
 : function to replace a tei sourceDoc chunk with new data
 :
 : @param $nodes the node-set to process
 : @param $source-doc the sourceDoc to insert
 : @return tei resource
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:replace-sourcedoc
    ( $nodes as node()*, $source-doc as node() ) as node()* {
    
    for $node in $nodes
    return 
        typeswitch($node)
        case text() return $node
        case processing-instruction() return $node
        case comment() return $node
        case element(tei:sourceDoc) return (
            $source-doc
        )
        default return (
            try {
                element { QName('http://www.tei-c.org/ns/1.0', $node/name()) }{
                    $node/@*,
                    trivia:replace-sourcedoc($node/node(), $source-doc)
                }
            }  catch * {
                trivia:replace-sourcedoc($node/node(), $source-doc)
            }
            
        )
};

(: *********************************************
 : ****    TRIVIA Zones to TEI Zones
 : ***
 : :)

(:~  
 : trivia:create-zones-xml-from-trivia-zones()
 : function to create hierarchicaly structured tei zones from trivia zones
 :
 : @param $trivia-zones trivia zones as array
 : @param $source-doc the sourceDoc to insert
 : @return structured tei:zone elements
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-zones-xml-from-trivia-zones
    ( $trivia-zones as array(*) ) as item()*{
    
    for $zone in $trivia-zones?*
    let $shape := $zone?shape_attributes
    let $region := $zone?region_attributes
    let $children := $zone?children
    let $name := $zone?region_attributes?name
    let $type := $zone?region_attributes?mapItem
    return 
        (: base case :)
        element { QName("http://www.tei-c.org/ns/1.0", "zone") }{
            attribute corresp { $zone?surfaceId || "#" || $zone?id },
            attribute xml:id { $zone?region_attributes?zoneId },
            if ( $name ) then ( attribute n { $name } ) else (),
            if ( $type ) then ( attribute type { $type } ) else (),
            trivia:create-zone-annotation( $zone ),
            (: recursion case :)
            if ( count($children) > 0 ) then (
                trivia:create-zones-xml-from-trivia-zones( $children )
            ) else ()
        }
        
};


declare function trivia:create-zone-annotation
    ( $trivia-zone as map(*) ) as item()*{
    
    let $region-annotations := (
        let $zone-attributes := $trivia-zone?region_attributes
        for $attribute-key in map:keys( $zone-attributes )
        let $attribute-value := $zone-attributes( $attribute-key )
        where not($attribute-key =("zoneId", "name", "childOf", "mapItem") )
        return 
            element { QName("http://www.tei-c.org/ns/1.0", "f") } {
                attribute name { $attribute-key },
                element { QName("http://www.tei-c.org/ns/1.0", "string") } {
                    $attribute-value
                }
            }
        )
    let $shape-annotations := (
        let $shape-attributes := $trivia-zone?shape_attributes
        for $attribute-key in map:keys( $shape-attributes )
        let $attribute-value := $shape-attributes( $attribute-key )
        return 
            element { QName("http://www.tei-c.org/ns/1.0", "f") } {
                attribute name { $attribute-key },
                element { QName("http://www.tei-c.org/ns/1.0", "string") } {
                    $attribute-value
                }
            }
        )
    return (
        if ( count($region-annotations) > 0 ) then (
            element { QName("http://www.tei-c.org/ns/1.0", "note") } {
                element { QName("http://www.tei-c.org/ns/1.0", "fs") } {
                    attribute type {"trivia-annotation"},
                    $region-annotations
                }
            }
        ) else ()(:,
        if ( count($shape-annotations) > 0 ) then (
            element { QName("http://www.tei-c.org/ns/1.0", "note") } {
                attribute target { '#'||$trivia-zone?id },
                element { QName("http://www.tei-c.org/ns/1.0", "fs") } {
                    attribute type {"shapet-annotation"},
                    $region-annotations
                }
            }
        ) else ():)
    )
    
    
};
(: *********************************************
 : ****  TRIVIA Surface to TRIVIA XML Resource
 : ***
 : :)

(:~  
 : trivia:create-trivia-xml-resource-from-trivia-surface()
 : function to create a trivia-xml from a trivia surface map
 :
 : @param $trivia-surface the trivia surface map
 : @return structured trivia xml resource
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-trivia-xml-resource-from-trivia-surface
    ( $trivia-surface as map(*) ) as item(){
    
    (: collecting all the attributes of a surface:)
    let $metadata := trivia:get-trivia-surface-metadata( $trivia-surface )
    let $id := $metadata?id
    let $title := $metadata?title
    let $file-attributes := $metadata?file_attributes
    let $size := $metadata?size
    
    let $trivia-zones := $trivia-surface?zones
    let $trivia-regions := $trivia-surface?regions
    
    let $svg-shapes := trivia:create-svg-container-xml( $file-attributes, $trivia-regions )
    let $annotations := trivia:create-annotation-container-xml( $trivia-regions )
    return 
        element trivia { 
            namespace{ "svg" }{"http://www.w3.org/2000/svg"},
            namespace{ "xlink" }{"http://www.w3.org/1999/xlink"},
            namespace{ "tei" }{"http://www.tei-c.org/ns/1.0"},
            element metadata {
                if ( $title ) then ( element title { $title } ) else (),
                element idno { $id },
                element size { $size },
                element attributes {
                    via:map-to-xml( $file-attributes )
                }
            },
            $svg-shapes,
            $annotations
        }
};


(:~  
 : trivia:create-trivia-xml-container-objects()
 : function to collectively create trivia xml, tei xml and the annotation container
 :
 : @param $trivia-surface the trivia surface map
 : @return sequende with tei, trivia and annotation
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-trivia-xml-container-objects
    ( $trivia-surface as map(*) ) as item()*{
    
    (: collecting all the attributes of a surface:)
    let $metadata := trivia:get-trivia-surface-metadata( $trivia-surface )
    let $file-attributes := $metadata?file_attributes
    
    let $trivia-zones := $trivia-surface?zones
    let $trivia-regions := $trivia-surface?regions
    
    let $zones := trivia:create-zones-xml-from-trivia-zones( $trivia-zones )
    let $shapes := trivia:create-svg-container-xml( $file-attributes, $trivia-regions )
    let $annotations := trivia:create-annotation-container-xml( $trivia-regions )
    return ($zones, $shapes, $annotations)
};


(: *********************************************
 : **** TRIVIA Shapes Annotation to XML
 : ***
 : :)

(:~  
 : trivia:create-annotation-container-xml()
 : function to create an annotation container for the trivia xml resource from a trivia-regions array
 :
 : @param $trivia-regions an array containing all annotations
 : @return sequende with tei, trivia and annotation
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY - this can be simplified in the function trivia:create-annotation-xml-from-trivia-regions below
 : @author Uwe Sikora
 :)
declare function trivia:create-annotation-container-xml
    ( $trivia-regions as array(*) ) as item()*{
    
    element annotations {
        trivia:create-annotation-xml-from-trivia-regions( $trivia-regions )
    }
};

(:~  
 : trivia:create-annotation-xml-from-trivia-regions()
 : function to create an annotation container for the trivia xml resource from a trivia-regions array
 :
 : @param $trivia-regions an array containing all annotations
 : @return sequende with tei, trivia and annotation
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-annotation-xml-from-trivia-regions
    ( $trivia-regions as array(*) ) as item()*{
    
    for $region in $trivia-regions?*
    let $region-attributes := $region?region_attributes
    return 
        element annotation {
            attribute target { '#' || $region-attributes?zoneId },
            via:map-to-xml( $region-attributes )
        }
};

(:*********************************************
 : ****    TRIVIA Shapes to SVG XML
 : ***
 : :)


(:~  
 : trivia:create-svg-container-xml()
 : function to create a svf xml container from trivia regions array
 :
 : @param $file-attributes the file attributes of the trivia surface
 : @param $trivia-regions an array containing all annotations
 : @return sequende with tei, trivia and annotation
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-svg-container-xml
    ( $file-attributes as map(*), $trivia-regions as array(*) ) as item()*{
    
    element { QName("http://www.w3.org/2000/svg", "svg:svg") }{
        element { QName("http://www.w3.org/2000/svg", "svg:g") }{
            element { QName("http://www.w3.org/2000/svg", "svg:image") }{
                attribute { "height" }{ $file-attributes?naturalHeight },
                attribute { "width" }{ $file-attributes?naturalWidth },
                attribute { "xlink:href" }{ $file-attributes?imageRef }
            },
            trivia:create-svg-shapes-xml-from-trivia-regions( $trivia-regions )
        }
    }
};


(:~  
 : trivia:create-svg-shapes-xml-from-trivia-regions()
 : function to create svg xml elements from trivia regions array
 :
 : @param $trivia-regions an array containing all annotations
 : @return sequende with tei, trivia and annotation
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-svg-shapes-xml-from-trivia-regions
    ( $trivia-regions as array(*) ) as item()*{
    
    for $region in $trivia-regions?*
    let $shape-attributes := $region?shape_attributes
    let $region-attributes := $region?region_attributes
    let $svg-shape := trivia:convert-via-shapes-to-svg-shapes( $shape-attributes )
    let $svg-element := trivia:create-svg-xml-elements( $svg-shape, map{'id':$region-attributes?zoneId} )
    return $svg-element
};


(:~  
 : trivia:create-svg-shapes-xml-from-trivia-zones()
 : function to create svg xml elements from trivia regions array
 :
 : @param $trivia-regions an array containing all annotations
 : @return sequende with tei, trivia and annotation
 : 
 : @version 0.1 (2019-05-22)
 : @author Uwe Sikora
 :)
declare function trivia:create-svg-shapes-xml-from-trivia-zones
    ( $trivia-zones as array(*) ) as item()*{
    
    let $flattened := trivia:flatten-trivia-zones( $trivia-zones )
    for $zone in $flattened
    let $shape-attributes := $zone?shape_attributes
    let $region-attributes := $zone?region_attributes
    let $svg-shape := trivia:convert-via-shapes-to-svg-shapes( $shape-attributes )
    let $svg-element := trivia:create-svg-xml-elements( $svg-shape, map{'id':$region-attributes?zoneId} )
    order by $zone?index ascending
    return (
        $svg-element
    )
};

declare function trivia:flatten-trivia-zones
    ( $trivia-zones as array(*) ) as item()*{
    
    for $zone in $trivia-zones?*
    let $aggregated-zones := $zone?children
    return (
        map{ "region_attributes" : $zone?region_attributes, "shape_attributes" : $zone?shape_attributes, "index" : $zone?index },
        if( count($aggregated-zones) > 0 ) then (
            trivia:flatten-trivia-zones( $aggregated-zones )
        ) else ()
    )
};


(:~  
 : trivia:convert-via-shapes-to-svg-shapes()
 : [via:convert-via-shapes-to-svg-shapes()]
 : function converting a via-shape (object of "shape_attributes") into svg-shapes
 :
 : @param $via-shape the via shape being converted
 : @return map()* the converted svg shape
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:convert-via-shapes-to-svg-shapes
    ( $via-shape as map() ) as map()? {
    
    let $name := $via-shape("name")
    let $via-shape := via:map-put($via-shape, "name", via:map-via-shape-name-to-svg-name( $name ) )
    return 
        if ($name = ("polyline", "polygon") ) then (
            let $map := map{"name" : $name}
            let $updated-map := via:map-put($map, "points",
                let $x-points := $via-shape("all_points_x")?*
                let $y-points := $via-shape("all_points_y")?*
                let $points := (
                    for $x at $i in $x-points
                    return concat($x, ",", $y-points[$i])
                )
                return string-join($points, " ")
            )
            return $updated-map
            
        ) else if ( $name = ( "point" ) ) then (
            let $updated-map := via:map-put($via-shape, "r", 2)
            return $updated-map
        ) 
        
        else (
            $via-shape
        )
};

(: *****************************************************************
 : ********     TEXTGRID COMMUNICATION
 : ***
 : :)

(:~  
 : trivia:create-trivia-xml-resource-in-textgrid()
 : function to create a trivia xml resource in textgrid
 :
 : @param $tg-config textgrid config
 : @param $title the title of the resource going to be created
 : @param $imageUri the linked image textgrid uri
 : @param $textUri the linked tei textgrid uri
 : @return map containing the uri and the title of the created resource
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-trivia-xml-resource-in-textgrid
    ( $tg-config as map(*), $title as xs:string, $imageUri as xs:string, $textUri as xs:string? ) as item()*{
    
    let $trivia-xml := trivia:trivia-xml-resource( $title, $imageUri, $textUri )
    let $create-resource := tgclient:create-resource($tg-config, $title, "text/trivia+xml", $trivia-xml)
    let $new-objects-uri := tgclient:parse-uri( $create-resource//*:generic//*:textgridUri/string() )("prefixed-base")
    return 
        if ( not( $create-resource/name() = "error" ) ) then ( 
            map{ "uri" : $new-objects-uri, "title" : $title } 
        ) else (
            map{ "error" : "could not create new resource" }
        ) 
};


(:~  
 : trivia:trivia-xml-resource()
 : function creating a barebone trivia xml
 :
 : @param $title the title of the resource going to be created
 : @param $imageUri the linked image textgrid uri
 : @param $textUri the linked tei textgrid uri
 : @return trivia xml resource
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:trivia-xml-resource
    ( $title as xs:string, $imageUri as xs:string, $textUri as xs:string? ) as item()*{
    
    element trivia { 
        namespace{ "svg" }{"http://www.w3.org/2000/svg"},
        namespace{ "xlink" }{"http://www.w3.org/1999/xlink"},
        namespace{ "tei" }{"http://www.tei-c.org/ns/1.0"},
        element metadata {
            element attributes {
                element image_url { },
                element title { $title },
                element imageRef { $imageUri },
                if ( $textUri ) then( element textRef { $textUri } ) else ()
            },
            element size { -1 }
        },
        element { QName("http://www.w3.org/2000/svg", "svg:svg") }{
            element { QName("http://www.w3.org/2000/svg", "svg:g") }{
                element { QName("http://www.w3.org/2000/svg", "svg:image") }{
                    attribute { "xlink:href" }{ $imageUri }
                }
            }
        },
        element annotations {}
    }
};


(:~  
 : trivia:create-tei-xml-resource-in-textgrid()
 : function creating a barebone tei xml in textgrid
 :
 : @param $tg-config textgrid config
 : @param $title the title of the resource going to be created
 : @return map containing the uri and the title of the created resource
 : 
 : @version 0.2 (2019-05-10)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function trivia:create-tei-xml-resource-in-textgrid
    ( $tg-config as map(*), $title as xs:string ) as item()*{
    
    let $tei-xml := <TEI xmlns="http://www.tei-c.org/ns/1.0">
       <teiHeader>
          <fileDesc>
             <titleStmt>
                <title>{ $title }</title>
             </titleStmt>
             <publicationStmt>
                <p>Publication Information</p>
             </publicationStmt>
             <sourceDesc>
                <p>born digital by trivia v1.0</p>
             </sourceDesc>
          </fileDesc>
       </teiHeader>
       <sourceDoc/>
       <text>
          <body>
             <p/>
          </body>
       </text>
    </TEI>
    let $create-resource := tgclient:create-resource($tg-config, $title, "text/xml", $tei-xml)
    let $new-objects-uri := tgclient:parse-uri( $create-resource//*:generic//*:textgridUri/string() )("prefixed-base")
    return 
        if ( not( $create-resource/name() = "error" ) ) then ( 
            map{ "uri" : $new-objects-uri, "title" : $title } 
        ) else (
            map{ "error" : "could not create new resource" }
        ) 
};