xquery version "3.1";
(:~  
 : Main App Module ("main", "http://dev.met.de/via/main")
 : *******************************************************************************************
 : This is the main module defining the functionalities of the app
 :  
 : @version 0.1 (2019-04-17)
 : @status develop
 : @author Uwe Sikora
 : 
 : Terms:
 : ******
 : via-object : a json string produced in via
 : via-surfaces : all images incl. metadata represented in via
 : shape-object
 :)
module namespace via="http://dev.met.de/via/main";
import module namespace console="http://exist-db.org/xquery/console";
declare default element namespace "http://dev.met.de/via/";
declare namespace test="http://exist-db.org/xquery/xqsuite";
declare namespace vias="http://dev.met.de/via/schema";
declare namespace svg="http://www.w3.org/2000/svg";
declare namespace tei="http://www.tei-c.org/ns/1.0";
declare namespace tg="http://textgrid.info/namespaces/metadata/core/2010";
declare namespace xlink="http://www.w3.org/1999/xlink";
declare namespace output = "http://www.w3.org/2010/xslt-xquery-serialization";

(:############################# Modules Variables #############################:)

 (:~  
 : $via:status
 : the status of the app 
 : 
 : @version 0.1 (2018-03-15)
 : @author Uwe Sikora
 :)
declare variable $via:status := "dev";

declare variable $via:tgcrud := "https://textgridlab.org/1.0/tgcrud/rest";
declare variable $via:sid := "cxKgCF0HYxWImEmBn9PLEPY8rhKU8Hk3Xo4PpR3q7EhAfAnTA994u6mr1554879267023764";
declare variable $via:pid := "TGPR-27cd40b2-1556-3cae-0f9f-5bf29f35397a" (: ilanot :);
declare variable $via:tg-config := map{"sid" : $via:sid, "pid" : $via:pid, "tgcrudURL" : $via:tgcrud};


declare variable $via:zones-json-sample := '[{"name": "shape_0","aggregates": 1, "index":0},{"name": "shape_1","aggregates": 2, "index":1},{"name": "shape_2","aggregates": 3, "index":2},{"name": "shape_5","aggregates": 0, "index":5}]';
declare variable $via:zones2 := '{"0":{"name": "shape_0","aggregates": 1, "index":0}, "1":{"name": "shape_1","aggregates": 2, "index":1},"2":{"name": "shape_2","aggregates": 3, "index":2},"5":{"name": "shape_5","aggregates": 0, "index":5}}';
declare variable $via:zones3 := '[{"name": "shape_5","aggregates": {"name": "shape_0","aggregates": {"name": "shape_1","aggregates": {"name": "shape_2","aggregates": {"name": "shape_3", "index":3}, "index":2}, "index":1}, "index":0}, "index":5}, {"name": "shape_4", "index":4}, {"name": "shape_6", "index":6}, {"name": "shape_7", "index":7}]';
declare variable $via:trivia-json := '{"magic.png1019453":{"zones":[{"surfaceId":"magic.png1019453","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"mag1","name":"LeonderMagier","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[307,235,237,154,127,71,157,111,60,16,11,42,79,150,173,196,247,244,205,161,187,245,346,335,365,390,436,450,494,544,556,515,480,499,581,628,658,669,665,468,503,540,570,616,627,605,549,517,494,480,494,514,499,480,454,429,378,365,372,401,381,346,325],"all_points_y":[21,67,146,108,196,344,286,369,494,646,729,732,664,558,607,699,715,796,861,891,916,914,867,715,715,771,824,891,920,921,888,830,736,692,665,657,690,651,602,353,367,344,282,229,146,94,67,79,124,166,205,240,274,281,256,201,168,173,120,99,65,30,11]}},"index":0,"aggregates":[{"surfaceId":"magic.png1019453","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"face1","name":"Gesicht","childOf":"mag1"},"shape_attributes":{"name":"circle","r":52,"cx":319,"cy":128}},"index":1,"id":"face1"},{"surfaceId":"magic.png1019453","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"hand1","name":"Magierhand","childOf":"mag1"},"shape_attributes":{"rx":54,"ry":72,"name":"ellipse","cx":557,"cy":167}},"index":2,"id":"hand1"}],"id":"mag1"}],"data":{"size":1.019453E6,"filename":"magic.png","zones":[{"name":"not_defined","index":"0","id":"0"},{"name":"Gesicht","index":"1","id":"1"},{"name":"Magierhand","index":"2","id":"2"}],"file_attributes":{"image_url":"","naturalHeight":926,"naturalWidth":676, "imageRef":"textgrid:1234","textRef":"textgrid:5678"},"regions":[{"region_attributes":{"ignoreGeometry":"no","zoneId":"mag1","name":"LeonderMagier","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[307,235,237,154,127,71,157,111,60,16,11,42,79,150,173,196,247,244,205,161,187,245,346,335,365,390,436,450,494,544,556,515,480,499,581,628,658,669,665,468,503,540,570,616,627,605,549,517,494,480,494,514,499,480,454,429,378,365,372,401,381,346,325],"all_points_y":[21,67,146,108,196,344,286,369,494,646,729,732,664,558,607,699,715,796,861,891,916,914,867,715,715,771,824,891,920,921,888,830,736,692,665,657,690,651,602,353,367,344,282,229,146,94,67,79,124,166,205,240,274,281,256,201,168,173,120,99,65,30,11]}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"face1","name":"Gesicht","childOf":"mag1"},"shape_attributes":{"name":"circle","r":52,"cx":319,"cy":128}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"hand1","name":"Magierhand","childOf":"mag1"},"shape_attributes":{"rx":54,"ry":72,"name":"ellipse","cx":557,"cy":167}}]},"name":"magic.png","measures":{"naturalHeight":926,"naturalWidth":676},"id":"magic.png1019453"},"ilan_sample1.jpeg180077":{"zones":[{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone6","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":47,"cx":752,"cy":805}},"index":5,"id":"zone6"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone7","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":51,"cx":549,"cy":1039}},"index":6,"aggregates":[{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone8","name":"not_defined","childOf":"zone7"},"shape_attributes":{"name":"circle","r":45,"cx":552,"cy":913}},"index":7,"id":"zone8"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone9","name":"Enzof","childOf":"zone7"},"shape_attributes":{"name":"circle","r":68,"cx":558,"cy":164}},"index":8,"id":"zone9"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone10","name":"not_defined","childOf":"zone7"},"shape_attributes":{"name":"polygon","all_points_x":[498,382,396,511],"all_points_y":[192,279,294,206]}},"index":9,"id":"zone10"}],"id":"zone7"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone11","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[608,706,722,618],"all_points_y":[210,290,275,196]}},"index":10,"id":"zone11"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone12","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[545,545,569,566],"all_points_y":[238,611,609,238]}},"index":11,"id":"zone12"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone13","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[725,582,598,743],"all_points_y":[370,615,625,373]}},"index":12,"id":"zone13"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone14","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[367,366,337,343],"all_points_y":[379,478,478,377]}},"index":13,"id":"zone14"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone0","name":"Theoneideleted","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":48,"cx":359,"cy":320}},"index":14,"aggregates":[{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone1","name":"not_defined","childOf":"zone0"},"shape_attributes":{"name":"circle","r":47,"cx":748,"cy":320}},"index":0,"aggregates":[{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone2","name":"SomeBubble","mapItem":"http://www.semanticweb.org/jahnke/ontologies/2019/3/ilanot#Angel","childOf":"zone1"},"shape_attributes":{"name":"circle","r":50,"cx":350,"cy":532}},"index":1,"id":"zone2"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone3","name":"Maythefourthbewithyou","childOf":"zone1"},"shape_attributes":{"name":"circle","r":45,"cx":751,"cy":536}},"index":2,"aggregates":[{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone4","name":"not_defined","childOf":"zone3"},"shape_attributes":{"name":"circle","r":48,"cx":558,"cy":661}},"index":3,"id":"zone4"},{"surfaceId":"ilan_sample1.jpeg180077","data":{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone5","name":"not_defined","childOf":"zone3"},"shape_attributes":{"name":"circle","r":46,"cx":354,"cy":802}},"index":4,"id":"zone5"}],"id":"zone3"}],"id":"zone1"}],"id":"zone0"}],"data":{"size":180077,"filename":"ilan_sample1.jpeg","file_attributes":{"image_url":"","naturalHeight":1200,"naturalWidth":935,"imageRef":"textgrid:1234","textRef":"textgrid:5678"},"regions":[{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone1","name":"not_defined","childOf":"zone0"},"shape_attributes":{"name":"circle","r":47,"cx":748,"cy":320}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone2","name":"SomeBubble","mapItem":"http://www.semanticweb.org/jahnke/ontologies/2019/3/ilanot#Angel","childOf":"zone1"},"shape_attributes":{"name":"circle","r":50,"cx":350,"cy":532}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone3","name":"Maythefourthbewithyou","childOf":"zone1"},"shape_attributes":{"name":"circle","r":45,"cx":751,"cy":536}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone4","name":"not_defined","childOf":"zone3"},"shape_attributes":{"name":"circle","r":48,"cx":558,"cy":661}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone5","name":"not_defined","childOf":"zone3"},"shape_attributes":{"name":"circle","r":46,"cx":354,"cy":802}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone6","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":47,"cx":752,"cy":805}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone7","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":51,"cx":549,"cy":1039}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone8","name":"not_defined","childOf":"zone7"},"shape_attributes":{"name":"circle","r":45,"cx":552,"cy":913}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone9","name":"Enzof","childOf":"zone7"},"shape_attributes":{"name":"circle","r":68,"cx":558,"cy":164}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone10","name":"not_defined","childOf":"zone7"},"shape_attributes":{"name":"polygon","all_points_x":[498,382,396,511],"all_points_y":[192,279,294,206]}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone11","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[608,706,722,618],"all_points_y":[210,290,275,196]}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone12","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[545,545,569,566],"all_points_y":[238,611,609,238]}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone13","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[725,582,598,743],"all_points_y":[370,615,625,373]}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone14","name":"not_defined","childOf":"not_defined"},"shape_attributes":{"name":"polygon","all_points_x":[367,366,337,343],"all_points_y":[379,478,478,377]}},{"region_attributes":{"ignoreGeometry":"no","zoneId":"zone0","name":"Theoneideleted","childOf":"not_defined"},"shape_attributes":{"name":"circle","r":48,"cx":359,"cy":320}}]},"name":"ilan_sample1.jpeg","measures":{"naturalHeight":1200,"naturalWidth":935},"id":"ilan_sample1.jpeg180077"}}';
(:############################# Modules Functions #############################:)

(: *****************************************************************
 : ********     General Functions
 : ***
 : :)
 
(:~  
 : via:cast-to-integer()
 : function trying to cast a string to an integer
 :
 : @param $string the string that should be cast
 : @return item() the numre as integer or string if it is not succesfull
 : 
 : @version 0.1 (2019-04-18)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function via:cast-to-integer
    ( $string as xs:string ) as item() {
    
    try{
        xs:integer($string)
    } catch * {
        $string
    }
};


(:~  
 : via:xml-to-map()
 : function to convert xml to a map recursively.
 :
 : @param $xml the xml maped to json
 : @return item() the json
 : 
 : @version 0.1 (2019-04-18)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function via:xml-to-map
    ( $xml as node()* ) as item() {
    
    map:new(
        for $node in $xml
        let $content := $node/node()
        where $node/name() != ''
        return 
            if ( count($content) = 0) then (
                map:entry( $node/name(), "" )
            ) else if ( count($content) = 1 and $content instance of text() and not($content = normalize-space("")) ) then (
                map:entry( 
                    $node/name(),
                    $content
                )
                (:$content:)
            ) else (
                map:entry( $node/name(), via:xml-to-map($content) )
            )
    )
};


(:~  
 : via:map-to-xml()
 : [local:create-xml-element()]
 : function to convert xml to a map recursively.
 :
 : @param $xml the xml maped to json
 : @return item() the json
 : 
 : @version 0.1 (2019-04-18)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function via:map-to-xml
    ( $map as map()* ) as item()* {
    
    for $elem in map:keys($map)
    return 
        element { $elem }{ 
            try {
                via:map-to-xml( $map( $elem ) )
            } catch *{
                $map( $elem )
            }
        }
};

(: *****************************************************************
 : ********     xquery map functions
 : ***
 : :)

(:~  
 : via:map-put()
 : helperfunction to update a map.
 :
 : @param $map the map being updated
 : @param $key the new key
 : @param $value the new value
 : @return map() the updated map 
 : 
 : @version 0.1 (2019-04-18)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function via:map-put
    ( $map as map(*), $key as xs:anyAtomicType, $value as item()* ) as map(*) {

    let $map-put := map:new ( ($map, map:entry($key, $value) ) ) (: "appending" value to a map by creating a new map:)
    return $map-put
};


(:~  
 : via:map-merge()
 : function to merge two maps
 :
 : @param $target-map the map beeing updated
 : @param $source-map the map providing the data to merge
 : @return map()* the updated map
 : 
 : @version 0.1 (2019-04-18)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function via:map-merge
    ( $target-map as map(*), $source-map as map(*) ) as map(*) {
    
    map:new((
        $target-map,
        for $key in map:keys($source-map)
        return map:entry( $key, $source-map($key) )
    ))
};


(: *****************************************************************
 : ********     TRIVIA Surface metadata
 : ***
 : :)


(:~  
 : via:map-via-shape-name-to-svg-name()
 : mappingfunction to map via to svg names
 :
 : @param $name the via name
 : @return xs:string the maped name or itself if nothing matches
 : 
 : @version 0.1 (2019-04-18)
 : @status OKAY
 : @author Uwe Sikora
 :)
declare function via:map-via-shape-name-to-svg-name
    ( $name as xs:string ) as xs:string {
    switch ( $name )
    case "point" return "circle"
    default return $name    
};