"use strict";

var VIAZONES_VERSION      = '2.0.6';
var VIAZONES_NAME         = 'VGG Image Annotator - Zones';


var _vz_img_zones = {};   // data structure to store loaded images metadata
var _vz_surfaces = {};
let surfaceIndex = _via_image_id_list;
let surfaceFilenames = _via_image_filename_list;
let surfaces = _via_img_metadata



class Surface {
  constructor( name ) { 
    this.zones = {};
    this.name = name;
    this.size;
  }

  fromVIAObject( obj ) {
    this.filename = obj.filename;
    
    for ( var i = 0; i < obj.regions.length; i++ ) {
      var item = obj.regions[i];
      var zone = new Zone( "", i+1).fromRegion( item );
      zone.addRelation( "canvas", this.name )
      this.zones[ i+1 ] = zone
    }
    return this
  }
}

class Zone {
  constructor( label="", nr="" ) {
    this.label = label
    this.nr = nr;
    this.shape = {};
    this.relations = []
  }

  fromRegion( region ) {
    this.label = region.region_attributes.name;
    this.shape[ "type" ] = region.shape_attributes.name;
    return this
  }
  
  addRelation( name, relatedObject ) {
    var relation = { "name" : name, "object" : relatedObject };
    this.relations.push( relation );
  }
}

function create_zones_from_img_regions( via_img_metadata ) {
  for ( var image_id in via_img_metadata ) {
    var image_obj = via_img_metadata[ image_id ];
    var surface = new Surface( image_id ).fromVIAObject( image_obj );
    _vz_surfaces[ image_id ] = surface;
  };

  return _vz_surfaces
}



function getMetadata( surfaceId ){
  return _via_img_metadata[ surfaceId ]
};

function updateMetadata( surfaceId, key, value){
  getMetadata( surfaceId )[key] = value
  return _via_img_metadata[ surfaceId ]  
};

function getBufferedImages(){
  let bufferObjects = {}
  
  for (let i = 0; i < surfaceIndex.length; i++) {
    let bufferedObject = document.getElementById("bim"+String(i));
    bufferObjects[ _via_image_id_list[i] ] = bufferedObject;
  };

  return bufferObjects
};

function getSurfaceSizeByImageId( surfaceId ){
  let buffered = getBufferedImages()[ surfaceId ]
  let naturalHeight = buffered.naturalHeight;
  let naturalWidth = buffered.naturalWidth;

  return { "naturalHeight" : naturalHeight, "naturalWidth" : naturalWidth }
};


function uinested() {
  let nestedList = document.getElementById("uinested");
};